---
- name: Docker swarm init
  when: inventory_hostname == groups[swarm_managers_group][0]
  community.docker.docker_swarm:
    state: present
    advertise_addr: "{{ ansible_default_ipv4.address }}"
  register: token

- name: Save tokens
  ansible.builtin.set_fact:
    manager_token: "{{ hostvars[groups[swarm_managers_group][0]].token.swarm_facts.JoinTokens.Manager }}"
    worker_token: "{{ hostvars[groups[swarm_managers_group][0]].token.swarm_facts.JoinTokens.Worker }}"

- name: Join workers to swarm
  community.docker.docker_swarm:
    state: join
    advertise_addr: "{{ ansible_default_ipv4.address }}"
    join_token: "{{ worker_token }}"
    remote_addrs: "{{ groups[swarm_managers_group] | map('extract', hostvars, ['ansible_default_ipv4', 'address']) | join(',') }}"
  when: inventory_hostname in groups[swarm_workers_group]

- name: Join managers to swarm
  community.docker.docker_swarm:
    state: join
    advertise_addr: "{{ ansible_default_ipv4.address }}"
    join_token: "{{ manager_token }}"
    remote_addrs: "{{ groups[swarm_managers_group] | map('extract', hostvars, ['ansible_default_ipv4', 'address']) | join(',') }}"
  when: inventory_hostname in groups[swarm_managers_group]
